/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#include "immediate.h"

namespace Msp {
namespace GL {

Immediate::Immediate(VertexFormat f):
	PrimitiveBuilder(array),
	array(f)
{ }

void Immediate::end_()
{
	array.apply();
	draw_elements(type, indices.size(), &indices[0]);

	array.clear();
	indices.clear();
}

void Immediate::element_(unsigned i)
{
	indices.push_back(i);
}

} // namespace GL
} // namespace Msp
