/* $Id$

This file is part of libmspgl
Copyright © 2007  Mikko Rasa, Mikkosoft Productions
Distributed under the LGPL
*/

#include "arb_vertex_buffer_object.h"
#include "extension.h"
#include "vertexbuffer.h"

namespace Msp {
namespace GL {

VertexBuffer::VertexBuffer()
{
	static RequireExtension _ext("GL_ARB_vertex_buffer_object");

	glGenBuffersARB(1, &id);
}

void VertexBuffer::bind() const
{
	glBindBufferARB(GL_ARRAY_BUFFER, id);
	bound=this;
}

void VertexBuffer::data(sizei size, void *d)
{
	if(bound!=this) bind();

	glBufferDataARB(GL_ARRAY_BUFFER, size, d, GL_STATIC_DRAW);
}

VertexBuffer::~VertexBuffer()
{
	glDeleteBuffersARB(1, &id);
}

void VertexBuffer::unbind()
{
	if(bound)
	{
		glBindBufferARB(GL_ARRAY_BUFFER, 0);
		bound=0;
	}
}

const VertexBuffer *VertexBuffer::bound=0;

} // namespace GL
} // namespace Msp
